<?php
// -----------------------------------------------------------------------
// Uhrumstellung von Sommer- auf Winterzeit und umgekehrt
// Script:  © S.G.Schiffer 2025 - sgs-visual.de
//
// Dieses Script darf nur mit der Quellenangabe (sgs-visual.de) genutzt werden!
// Dieses Script darf nicht auf anderen Domains angeboten oder verkauft werden!
// 
// Ich übernehme keine Haftung für die Funktionalität meines Scriptes oder Korrektheit der ausgegeben Daten.
// Es gibt keinen Anspruch auf Schadens- oder Ersatzansprüche durch die Nutzung des Scriptes.
// Es gibt keinen Support für Probleme, die bei der Anpassung des Scriptes entstehen können.
// -----------------------------------------------------------------------

date_default_timezone_set('Europe/Berlin');
setlocale(LC_TIME, 'de_DE.UTF-8', 'de_DE', 'deu_deu');

$aktuellesJahr = date('Y');
$heute = date('Y-m-d');

// Hilfsfunktionen für Zeitumstellung
function letzter_sonntag($monat, $jahr) {
    return date('Y-m-d', strtotime("last sunday of $jahr-$monat"));
}
function sommerzeit_start($jahr) {
    return letzter_sonntag(3, $jahr);
}
function sommerzeit_ende($jahr) {
    return letzter_sonntag(10, $jahr);
}

// Berechne relevante Daten für aktuelles und nächstes Jahr
$jahr = (int)date('Y');
$start_sommer = sommerzeit_start($jahr);
$ende_sommer = sommerzeit_ende($jahr);
$start_sommer_next = sommerzeit_start($jahr + 1);
$ende_sommer_prev = sommerzeit_ende($jahr - 1);

$now = strtotime('today');
$start_sommer_ts = strtotime($start_sommer);
$ende_sommer_ts = strtotime($ende_sommer);
$start_sommer_next_ts = strtotime($start_sommer_next);
$ende_sommer_prev_ts = strtotime($ende_sommer_prev);

// Textbausteine dynamisch erzeugen
$anzeige = '';

// Tag der Umstellung auf Sommerzeit
if ($now == $start_sommer_ts) {
    $anzeige = "
    <div class='box'>
      <div class='tab'>
        <div class='tab_raum' style='display:inline-block;vertical-align:top;width:100%;'>
          <b class='zeitraum_heute'>Heute Nacht Uhr umstellen!</b><br>
          <b>Heute Nacht</b> wird die Uhr von <b>02:00 Uhr</b> auf <b>03:00 Uhr Sommerzeit</b> vorgestellt.<br><br>
          <center><b><i class='quelle'>Quelle: &copy; <a class='quelle' href='https://www.sgs-visual.de'>sgs-visual.de</a> $aktuellesJahr &emsp;&#128194; </b>PHP-Script</i></center>
        </div>
      </div>
    </div>";
}
// Tag der Umstellung auf Winterzeit
elseif ($now == $ende_sommer_ts) {
    $anzeige = "
    <div class='box'>
      <div class='tab'>
        <div class='tab_raum' style='display:inline-block;vertical-align:top;width:100%;'>
          <b class='zeitraum_heute'>Heute Nacht Uhr umstellen!</b><br>
          <b>Heute Nacht</b> wird die Uhr von <b>03:00 Uhr</b> auf <b>02:00 Uhr Winterzeit [Normalzeit]</b> zurück gestellt.<br><br>
          <center><b><i class='quelle'>Quelle: &copy; <a class='quelle' href='https://www.sgs-visual.de'>sgs-visual.de</a> $aktuellesJahr &emsp;&#128194; </b>PHP-Script</i></center>
        </div>
      </div>
    </div>";
}
// Sommerzeit aktiv
elseif ($now > $start_sommer_ts && $now < $ende_sommer_ts) {
    $anzeige = "
    <div class='box'>
      <div class='tab'>
        <div class='tab_raum' style='display:inline-block;vertical-align:top;width:100%;'>
          <b class='zeitraum_sommer'>Aktuell gilt die Sommerzeit</b><br>
          Am <b>".strftime('%d.%m.%Y', $ende_sommer_ts)."</b> wird die Uhr von <b>03:00 Uhr</b> auf <b>02:00 Uhr Winterzeit [Normalzeit]</b> zurück gestellt.<br><br>
          <center><b><i class='quelle'>Quelle: &copy; <a class='quelle' href='https://www.sgs-visual.de'>sgs-visual.de</a> $aktuellesJahr &emsp;&#128194; </b>PHP-Script</i></center>
        </div>
      </div>
    </div>";
}
// Winterzeit aktiv
else {
    $anzeige = "
    <div class='box'>
      <div class='tab'>
        <div class='tab_raum' style='display:inline-block;vertical-align:top;width:100%;'>
          <b class='zeitraum_winter'>Aktuell gilt die Winterzeit</b><br>
          Am <b>".strftime('%d.%m.%Y', $start_sommer_next_ts)."</b> wird die Uhr von <b>02:00 Uhr</b> auf <b>03:00 Uhr Sommerzeit</b> vorgestellt.<br><br>
          <center><b><i class='quelle'>Quelle: &copy; <a class='quelle' href='https://www.sgs-visual.de'>sgs-visual.de</a> $aktuellesJahr &emsp;&#128194; </b>PHP-Script</i></center>
        </div>
      </div>
    </div>";
}

// Aktuelles Datum mit ausgeschriebenem Wochentagsnamen (deutsch)
$wochentag = strftime('%A', $now);
$datum_lang = strftime('%d. %B %Y', $now);
$datum_anzeige = "$wochentag, $datum_lang";

// Grafik für die nächste Umstellung bestimmen
if ($now >= $start_sommer_ts && $now < $ende_sommer_ts) {
    // Sommerzeit aktiv: nächste Umstellung ist auf Winterzeit
    $img_rechts = "<img src='szwz/winterzeit.png' width='79' height='100' alt='Winterzeit' style='margin-left:20px;'>";
} else {
    // Winterzeit aktiv: nächste Umstellung ist auf Sommerzeit
    $img_rechts = "<img src='szwz/sommerzeit.png' width='89' height='93' alt='Sommerzeit' style='margin-left:20px;'>";
}
?>

<!DOCTYPE html>
<html lang="de">
<head>
    <title>Uhrumstellung</title>
    <meta charset="utf-8" />
    <meta http-equiv="content-language" content="de" />
    <meta name="description" content="Termine für die Uhrumstellung Sommer- und Normalzeit" />
    <meta name="author" content="Stefan G. Schiffer" />
    <meta http-equiv="last-modified" content="2025-06-16"/>
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <style>
        .box {
         border-radius: 25px;
         background: #FFFFFF;
         padding: 0px;
         width: 315px;
         height: auto;
         border: 0px dotted #000000;
         margin: 0 auto;
         }
        .tab {
         border-collapse:collapse;
         font-family: Arial, Helvetica, Verdana, Tahoma, sans-serif;
         color: #000000;
         font-size: 14px;
         font-style: normal;
         width: 100%;
         display: table;
         }
         .tab_raum {
         padding: 5px;
         display: table-cell;
         vertical-align: middle;
         }
         .zeitraum_sommer {
         font-family: Arial, Helvetica, Verdana, Tahoma, sans-serif;
         color: #E88000;
         font-style: bold;
         font-size: 16px;
         text-shadow: 1px 1px #62758B;
         }
         .zeitraum_winter {
         font-family: Arial, Helvetica, Verdana, Tahoma, sans-serif;
         color: #218BDD;
         font-style: bold;
         font-size: 16px;
         text-shadow: 1px 1px #62758B;
         }
         .zeitraum_heute {
         font-family: Arial, Helvetica, Verdana, Tahoma, sans-serif;
         color: #000000;
         font-style: bold;
         font-size: 16px;
         text-shadow: 1px 1px #62758B;
         }
         .quelle {
         font-family: Arial, Helvetica, Verdana, Tahoma, sans-serif;
         color: #585858;
         text-decoration: none;
         font-size: 8px;
         }
         .clock-row {
            width: 100%;
            display: flex;
            justify-content: center;
            align-items: center;
            margin-bottom: 6px;
            margin-top: 20px;
         }
         .clock-col {
            display: flex;
            flex-direction: column;
            align-items: center;
         }
         .clock-date {
            margin-top: 6px;
            font-family: Arial, Helvetica, Verdana, Tahoma, sans-serif;
            font-size: 15px;
            color: #222;
            text-align: center;
         }
    </style>
</head>
<body>
    <div class="clock-row">
        <div class="clock-col">
            <canvas id="clock" width="66" height="66" style="background:transparent;"></canvas>
            <div class="clock-date"><?php echo htmlspecialchars($datum_anzeige, ENT_QUOTES, 'UTF-8'); ?></div>
        </div>
        <?php echo $img_rechts; ?>
    </div>
    <div style="width:100%;display:flex;justify-content:center;">
        <?php echo $anzeige; ?>
    </div>
<script>
const canvas = document.getElementById('clock');
const ctx = canvas.getContext('2d');
const radius = 30;
const centerX = 33;
const centerY = 33;

// Abstand des äußeren Kreises zu den Stundenstrichen
const outerCircleOffset = 3;
const outerCircleRadius = radius - 1 + outerCircleOffset; // 3px Abstand + 1px Rand

function drawClock() {
    ctx.clearRect(0, 0, 66, 66);

    // Uhrzeit in Europe/Berlin holen
    const now = new Date();
    const berlinTime = new Date(now.toLocaleString("en-US", {timeZone: "Europe/Berlin"}));
    let hour = berlinTime.getHours();
    let minute = berlinTime.getMinutes();
    let second = berlinTime.getSeconds();

    // Äußerer Kreis (2px, #555555, 3px Abstand zu Stundenstrichen)
    ctx.save();
    ctx.beginPath();
    ctx.arc(centerX, centerY, outerCircleRadius, 0, 2 * Math.PI);
    ctx.strokeStyle = "#555555";
    ctx.lineWidth = 2;
    ctx.stroke();
    ctx.restore();

    // Stundenstriche (nur alle 5 Minuten)
    for (let i = 0; i < 60; i += 5) {
        ctx.save();
        ctx.translate(centerX, centerY);
        ctx.rotate(i * Math.PI / 30);
        ctx.beginPath();
        ctx.moveTo(0, -radius + 3);
        ctx.lineTo(0, -radius + 9);
        ctx.strokeStyle = "#222";
        ctx.lineWidth = 2;
        ctx.stroke();
        ctx.restore();
    }

    // Stundenzeiger
    let hourAngle = ((hour % 12) + minute / 60) * Math.PI / 6;
    ctx.save();
    ctx.translate(centerX, centerY);
    ctx.rotate(hourAngle);
    ctx.beginPath();
    ctx.moveTo(0, 0);
    ctx.lineTo(0, -radius * 0.5);
    ctx.strokeStyle = "#222";
    ctx.lineWidth = 3;
    ctx.lineCap = "round";
    ctx.stroke();
    ctx.restore();

    // Minutenzeiger
    let minuteAngle = (minute + second / 60) * Math.PI / 30;
    ctx.save();
    ctx.translate(centerX, centerY);
    ctx.rotate(minuteAngle);
    ctx.beginPath();
    ctx.moveTo(0, 0);
    ctx.lineTo(0, -radius * 0.75);
    ctx.strokeStyle = "#444";
    ctx.lineWidth = 2;
    ctx.lineCap = "round";
    ctx.stroke();
    ctx.restore();

    // Sekundenzeiger
    let secondAngle = second * Math.PI / 30;
    ctx.save();
    ctx.translate(centerX, centerY);
    ctx.rotate(secondAngle);
    ctx.beginPath();
    ctx.moveTo(0, 4); // etwas über Mitte hinaus
    ctx.lineTo(0, -radius + 2);
    ctx.strokeStyle = "#e00";
    ctx.lineWidth = 1;
    ctx.lineCap = "round";
    ctx.stroke();
    ctx.restore();

    // Mittelpunkt
    ctx.beginPath();
    ctx.arc(centerX, centerY, 2, 0, 2 * Math.PI);
    ctx.fillStyle = "#222";
    ctx.fill();
}

setInterval(drawClock, 1000);
drawClock();
</script>
</body>
</html>